
import os, sys

from javax.swing.filechooser import FileFilter
from javax.swing import JFileChooser


def getExtension(fileStr):
    ext = None
    try:
        ext = fileStr[fileStr.index('.')+1 : ]
    except:
        pass
    return ext


class RDFFileFilter(FileFilter):
    def __init__(self):
        FileFilter.__init__(self)

    def getDescription(self):
        return 'RDF/XML files (*.rdf)'

    def getExtension(self):
        return 'rdf'

    def accept(self, file):
        ext = getExtension(file.name)
        
        if file.isDirectory() or ext == 'rdf':
            return 1
        else:
            return 0

class N3FileFilter(FileFilter):
    def __init__(self):
        FileFilter.__init__(self)

    def getDescription(self):
        return 'N3 files (*.n3)'

    def getExtension(self):
        return 'n3'

    def accept(self, file):
        ext = getExtension(file.name)        
        
        if file.isDirectory() or ext == 'n3':
            return 1
        else:
            return 0

class NTriplesFileFilter(FileFilter):
    def __init__(self):
        FileFilter.__init__(self)

    def getDescription(self):
        return 'N-TRIPLE files (*.nt)'

    def getExtension(self):
        return 'nt'

    def accept(self, file):
        ext = getExtension(file.name)        
        
        if file.isDirectory() or ext == 'nt':
            return 1
        else:
            return 0

class RDFModelChooser(JFileChooser):

    def __init__(self, path=os.getcwd()):
        JFileChooser.__init__(self, path)
        rfilt = RDFFileFilter()
        self.addChoosableFileFilter(rfilt)
        self.addChoosableFileFilter(N3FileFilter())
        self.addChoosableFileFilter(NTriplesFileFilter())

        self.fileFilter = rfilt
        


if __name__ == '__main__':
    chooser = RDFModelChooser()
    chooser.showOpenDialog(None)
    
    sys.exit(0)
