
from com.hp.hpl.jena.rdf.model import ModelFactory

from com.hp.hpl.jena.vocabulary import VCARD

from java.io import FileInputStream, FileOutputStream, InputStreamReader



def test():
    inputFileName = "vc-db-1.rdf"

    johnSmithURI = "http://somewhere/JohnSmith/"

    model = ModelFactory.createDefaultModel()

    fin = FileInputStream(inputFileName)

    model.read(InputStreamReader(fin), "");

    # Retrieve the Adam Smith vcard resource from the model
    vcard = model.getResource(johnSmithURI);


    # Retrieve the value of the N property
    name = vcard.getRequiredProperty(VCARD.N)   \
                .getObject();

    # Retrieve the given name property
    fullName = vcard.getRequiredProperty(VCARD.FN)  \
                    .getString();

    # Add two nick name properties to vcard
    vcard.addProperty(VCARD.NICKNAME, "Smithy")     \
         .addProperty(VCARD.NICKNAME, "Adman")

    # Set up the output
    print 'The nicknames of "%s" are: ' % fullName

    # List the nicknames
    iter = vcard.listProperties(VCARD.NICKNAME);

    while iter.hasNext():
        print "    " + iter.nextStatement().getObject()     \
                                           .toString()

    # Output the modified model into a file
    fout = FileOutputStream('mymodel.rdf')
    model.write(fout, 'RDF/XML')
    

if __name__ == '__main__':
    print 'Running the test...'
    test()
